﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

/*
 * Generated 8/23/2018 6:15:16 PM
 * Copyright TimH 2018
 * 
 * destinationdirectory:        C:\Users\TimH\Source\Repos\TcHmiProject44\TcHmiEnterTextbox
 * TcHmi_DefaultParameters:     [$guid1$, b0e76921-a013-497f-b9a9-d5333ebad39f] | [$guid2$, 03abad25-3604-436f-95eb-02d127040aef] | [$guid3$, e37166a7-5fe6-4af9-8625-ff62fc6908bf] | [$guid4$, 5dcc1692-1735-44c8-9fa7-4c55bcfcbe7b] | [$guid5$, 91e13711-296c-476c-8a47-f6aff273b0d0] | [$guid6$, 6df62ecc-b84e-4c35-bf3e-ab008c3a8643] | [$guid7$, d5f753e9-f04d-4eae-bdca-633e01914692] | [$guid8$, f9eb0efc-3385-4dc9-84c9-0b88190a1369] | [$guid9$, 46097906-d6cc-4bb1-a52d-88561d50ffcf] | [$guid10$, 1b90533c-1f08-4133-9f56-f4b5f799bc2d] | [$time$, 8/23/2018 6:15:16 PM] | [$year$, 2018] | [$username$, TimH] | [$userdomain$, BECKHOFF] | [$machinename$, TIMH-NB02] | [$clrversion$, 4.0.30319.42000] | [$registeredorganization$, ] | [$runsilent$, False] | [$solutiondirectory$, C:\Users\TimH\Source\Repos\TcHmiProject44\] | [$projectname$, TcHmiEnterTextbox] | [$safeprojectname$, TcHmiEnterTextbox] | [$currentuiculturename$, en-US] | [$installpath$, C:\Program Files (x86)\Microsoft Visual Studio\2017\Professional\Common7\IDE\] | [$specifiedsolutionname$, TcHmiEnterTextbox] | [$exclusiveproject$, False] | [$destinationdirectory$, C:\Users\TimH\Source\Repos\TcHmiProject44\TcHmiEnterTextbox] | [$targetframeworkversion$, 4.5]
 * projectname_tchmi:           TcHmiEnterTextbox
 * projectname_tchmi_dashcase:  tc-hmi-enter-textbox
 * safeprojectname:             TcHmiEnterTextbox
 * projectname:                 TcHmiEnterTextbox
 */

/**
*  Namespace: TcHmi
*  [REQUIRED]
*/
(function (TcHmi) {
    /**
    *  Namespace: TcHmi.Controls
    *  [REQUIRED]
    */
    (function (Controls) {
        /**
         *  Namespace: TcHmi.Controls.Custom
         *  [CUSTOM]
         */
        var Custom;
        (function (Custom) {
            /** TcHmiValidationTextbox object */
            var TcHmiValidationTextbox = (function (_super) {
                __extends(TcHmiValidationTextbox, _super);

                /*
                Attribute philosophy
                --------------------
                - Local variables are not set while definition in class, so they have the value 'undefined'.
                - On compile the Framework sets the value from HTML or from theme (possibly 'null') via normal setters
                - The "changed detection" in the setter will result in processing the value only once while compile
                - Attention: If we have a Server Binding on an Attribute the setter can be very late or never (leaving the value = undefined).
                */

                /**
                 * @description Constructor of the control
                 * @param {JQuery} element Element from HTML (internal, do not use)
                 * @param {JQuery} pcElement precompiled Element (internal, do not use)
                 * @param {TcHmi.Controls.ControlAttributeList} attrs Attributes defined in HTML in a special format (internal, do not use)
                 * @returns {void}
                 */
                function TcHmiValidationTextbox(element, pcElement, attrs) {
                    /** Call base constructor */
                    _super.call(this, element, pcElement, attrs);

                    this.__minValue = null;
                    this.__maxValue = null;
                    this.__blockInvalidInput = false;
                    this.__destroyOnTextChanged = null;

                    /** Declare event namespaces for unique event listeners to prevent unregistering wrong events in some cases (heredity e.g.) */
                    var guid = tchmi_create_guid();
                    this.__eventKeyDown = 'keydown.' + guid;                   
                }
                /** 
                * @description Is called during control initialize phase before attribute setter are called based on initial html dom values. 
                * @returns {void}
                */
                TcHmiValidationTextbox.prototype.__previnit = function () {
                    /** Handle template elements. Should be done before call to __previnit of super class. */
                    this.__elementTemplateRoot = this.__element.find('.tc-hmi-validation-textbox-template');
                    this.__elementTextarea = this.__elementTemplateRoot.find('.tchmi-textbox-template-input');
                    
                    /** Call __previnit of super class with the correct instance. */
                    _super.prototype.__previnit.call(this);
                };
                /** 
                 * @description Is called during control initialize phase after attribute setter have been called based on it's default or initial html dom values. 
                 * @returns {void}
                 */
                TcHmiValidationTextbox.prototype.__init = function () {
                    /** Call __init of super class with the correct instance. */
                    _super.prototype.__init.call(this);

                };
                /**
                * @description Is called after the control instance gets part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @returns {void}
                */
                TcHmiValidationTextbox.prototype.__attach = function () {
                    /** Call __attach of super class with the correct instance. */
                    _super.prototype.__attach.call(this);                    

                    /**
                     * Initialize everything which is only available while the control is part of the active dom.
                     */

                    // Register event listener
                    this.__elementTextarea.on(this.__eventKeyDown, this.__onTextareaKeyDown());
                    if (!this.__blockInvalidInput) {
                        this.__destroyOnTextChanged = TcHmi.EventProvider.register(this.getId() + '.onTextChanged', this.__onTextChanged());
                    }
                };
                /**
                * @description Is called after the control instance is no longer part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @returns {void}
                */
                TcHmiValidationTextbox.prototype.__detach = function () {
                    /** Call __detach of super class with the correct instance. */
                    _super.prototype.__detach.call(this);

                    /**
                     * Disable everything which is not needed while the control is not part of the active dom.
                     * No need to listen to events for example!
                     */

                    // Unregister event listener 
                    this.__elementTextarea.off(this.__eventKeyDown);

                    if (this.__destroyOnTextChanged) {
                        this.__destroyOnTextChanged();
                    }
                };
                /**
                * @description Destroy the current control instance. 
                * Will be called automatically if system destroys control!
                * @returns {void}
                */
                TcHmiValidationTextbox.prototype.destroy = function () {
                    /** Call destroy of super class with the correct instance. */
                    _super.prototype.destroy.call(this);

                    /**
                    * Free resources like child controls etc.
                    */
                };

                TcHmiValidationTextbox.prototype.setMinValue = function (valueNew) {
                    // convert the value with the value converter
                    var convertedValue = TcHmi.ValueConverter.toNumber(valueNew);

                    // check if the converted value is valid
                    if (convertedValue === null) {
                        // if we have no value to set we have to fall back to the defaultValueInternal from description.json
                        convertedValue = this.getAttributeDefaultValueInternal('MinValue');
                    }

                    if (tchmi_equal(convertedValue, this.__minValue)) {
                        // skip processing when the value has not changed
                        return;
                    }

                    // remember the new value
                    this.__minValue = convertedValue;

                    // inform the system that the function has a changed result.
                    TcHmi.EventProvider.raise(this.__id + ".onFunctionResultChanged", ["getMinValue"]);
                };

                TcHmiValidationTextbox.prototype.getMinValue = function () {
                    return this.__minValue;
                };                

                TcHmiValidationTextbox.prototype.setMaxValue = function (valueNew) {
                    // convert the value with the value converter
                    var convertedValue = TcHmi.ValueConverter.toNumber(valueNew);

                    // check if the converted value is valid
                    if (convertedValue === null) {
                        // if we have no value to set we have to fall back to the defaultValueInternal from description.json
                        convertedValue = this.getAttributeDefaultValueInternal('MaxValue');
                    }

                    if (tchmi_equal(convertedValue, this.__maxValue)) {
                        // skip processing when the value has not changed
                        return;
                    }

                    // remember the new value
                    this.__maxValue = convertedValue;

                    // inform the system that the function has a changed result.
                    TcHmi.EventProvider.raise(this.__id + ".onFunctionResultChanged", ["getMaxValue"]);
                };

                TcHmiValidationTextbox.prototype.getMaxValue = function () {
                    return this.__maxValue;
                };

                TcHmiValidationTextbox.prototype.setBlockInvalidInput = function (valueNew) {
                    // convert the value with the value converter
                    var convertedValue = TcHmi.ValueConverter.toBoolean(valueNew);

                    // check if the converted value is valid
                    if (convertedValue === null) {
                        // if we have no value to set we have to fall back to the defaultValueInternal from description.json
                        convertedValue = this.getAttributeDefaultValueInternal('BlockInvalidInput');
                    }

                    if (tchmi_equal(convertedValue, this.__blockInvalidInput)) {
                        // skip processing when the value has not changed
                        return;
                    }

                    // remember the new value
                    this.__blockInvalidInput = convertedValue;

                    // inform the system that the function has a changed result.
                    TcHmi.EventProvider.raise(this.__id + ".onFunctionResultChanged", ["getBlockInvalidInput"]);
                };

                TcHmiValidationTextbox.prototype.getBlockInvalidInput = function () {
                    return this.__blockInvalidInput;
                };
                
                /**
				 * @description Overwrite Eventhandler for __onTextChanged
				 * @returns {function} Handler for the event __onTextChanged
				 */
                TcHmiValidationTextbox.prototype.__onTextChanged = function () {
                    var _this = this;
                    return function (eventData) {
                        // Check the current text in the textbox
                        _this.__validateInput(_this);
                    };
                };

                TcHmiValidationTextbox.prototype.__validateInput = function (_this) {
                    // Get current text of the textbox
                    var text = this.getText();

                    if (!text) {
                        _this.__SetHighlightColor(true);
                        return false;
                    }

                    // convert to number
                    var number = Number(text);

                    if (_this.__minValue) {
                        // min value is set
                        if (number < _this.__minValue) {
                            _this.__SetHighlightColor(false);
                            return false;
                        }
                    }

                    if (_this.__maxValue) {
                        // max value is set
                        if (number > _this.__maxValue) {
                            _this.__SetHighlightColor(false);
                            return false;
                        }
                    }                    

                    _this.__SetHighlightColor(true);
                    return true;
                };

                TcHmiValidationTextbox.prototype.__SetHighlightColor = function (res) {                       
                    if (res) {
                        this.setBackgroundColor(null);                                            
                    }
                    else {
                        this.setBackgroundColor({ "color": "rgba(255, 0, 0, 1)" });                        
                    }                    
                };      

                /**
				 * @description Eventhandler for __processMultiline
                 * Will be called if the textbox switches into a textarea or back when the multiline option is used
				 */
                TcHmiValidationTextbox.prototype.__processMultiline = function () {
                    /** Call base __processMultiline function */
                    _super.prototype.__processMultiline.call(this);

                    // Update the reference to the textarea element
                    this.__elementTextarea = this.__elementTemplateRoot.find('.tchmi-textbox-template-input');

                    // Reregister on the key down event of the textarea
                    this.__elementTextarea.on(this.__eventKeyDown, this.__onTextareaKeyDown());
                };

                /**
				 * @description Eventhandler for __onTextareaKeyDown
				 * @returns {function} Handler for the event __onTextareaKeyDown
				 */
                TcHmiValidationTextbox.prototype.__onTextareaKeyDown = function () {
                    var _this = this;
                    return function (eventData) {
                        // check if the key is a number                  
                        var key = eventData.key;

                        var keyCode = eventData.keyCode;

                        var isSpecialKey = eventData.altKey || eventData.ctrlKey || eventData.metaKey || eventData.shiftKey;
                        var isCursorKey = keyCode >= 37 && keyCode <= 40;
                        var isBackspaceKey = keyCode === 8;
                        var isEnterKey = keyCode === 13;
                        var isEscKey = keyCode === 27;
                        var isSpaceKey = keyCode === 32;
                        var isDelKey = keyCode === 46;
                        var isDecimalPointKey = keyCode === 110;
                        var isPeriodKey = keyCode === 190;
                        var isSubtractKey = keyCode === 109;
                        var isExceptionKey = isSpecialKey || isCursorKey || isBackspaceKey || isEnterKey || isEscKey || isSpaceKey || isDelKey || isDecimalPointKey || isPeriodKey || isSubtractKey;
                        
                        if (!isExceptionKey) {
                            if (isNaN(Number(key))) {
                                eventData.preventDefault();
                                return false;
                            }
                        }

                        if (_this.__blockInvalidInput) {
                            var text = _this.getText();

                            if (!isNaN(key) || isSubtractKey) {
                                if (this.selectionStart === 0 && this.selectionEnd !== 0) {
                                    text = key;
                                } else {
                                    text = _this.getText() + key;
                                }
                            }

                            // convert to number
                            var number = Number(text);

                            if (_this.__minValue) {
                                // min value is set
                                if (number < _this.__minValue) {
                                    _this.__SetHighlightColor(false);
                                    eventData.preventDefault();
                                    return false;
                                }
                            }

                            if (_this.__maxValue) {
                                // max value is set
                                if (number > _this.__maxValue) {
                                    _this.__SetHighlightColor(false);
                                    eventData.preventDefault();
                                    return false;
                                }
                            }

                            _this.__SetHighlightColor(true);
                            return true;
                        }
                    };
                };

                return TcHmiValidationTextbox;
            })(TcHmi.Controls.Beckhoff.TcHmiTextbox);
            Custom.TcHmiValidationTextbox = TcHmiValidationTextbox;
        })(Custom = Controls.Custom || (Controls.Custom = {}));
        /**
        * Register control...
        */
        Controls.register('tc-hmi-validation-textbox', Custom.TcHmiValidationTextbox, 'Custom/TcHmiValidationTextbox/', 'Custom/TcHmiValidationTextbox/Template.html');
    })(Controls = TcHmi.Controls || (TcHmi.Controls = {}));
})(TcHmi);